Date: Thu 23 Feb 89 13:59:35-PST
Subject: ICOM CI-V Command Set

THE ICOM CI-V COMPUTER <=> RADIO BUS

The following is a summary of ICOM CI-V bus commands and reply
messages.  A couple of years ago, I got interested in controlling my
ICOM radios via the CI-V bus, the latest in a series of ICOM schemes
for controlling radios.  The control capabilities ICOM provides within
the radios are not as extensive as Kenwood's, but it is a CSMA/CD bus,
and only requires a single interface per computer.  Multiple radios
and computers can share the bus.

I wrote an article about the CI-V bus and submitted it to Ham Radio.
They told me that they were getting complaints that they published too
many computer-oriented articles and too few radio-oriented articles.
It was also pretty long.  I revised it but never resubmitted it.

The attached command summary is a bit old, since ICOM has produced
some new radios since then (the 375, 575 and 781 included).  I have
tested the commands thoroughly on the 735, 275, 475, R7000 and to a
lesser extent on the 751 (with the CI-V update installed).  The
command summary does include some commands I found on my 275 and 475
that may still not be documented.

ICOM's consistency leaves a lot to be desired.  There is a lot of
variation between radios, some necessary, some not.  The R7000 command
set differs quite a bit from that of the transceivers.

In the summary, TX Mode means that the radio's internal switch block
(generally buried as deeply inside as ICOM can put it) is set so that
the radio reports any changes in mode or frequency automatically.  TX
Mode is short for transcieve mode, and allows a second radio (say a
receiver) to be slaved to a master radio.  No computer is required.

I have been unsuccessful in trying to "fudge" any of the rigs outside
of their normal frequency range.  I'd be very interested if anyone
else has managed it.  I'm not sure how well the radios do CSMA/CD.  If
you have multiple radios on the bus I find that TX Mode is best turned
off.  Also you may want to resist the temptation to use 9600 baud.
1200 seems to be a lot more reliable.

I do highly endorse the CT-16 satellite control interface.  Even if
you have a computer in the shack, it frees up the computer for
tracking, etc.  The CT-16 doesn't handle Doppler shift, but on Phase 3
Modes B and J Doppler is not a big deal.  The older radios (271, 471,
1271, 751, etc.) can be retrofitted with a CI-V bus adapter, and the
CT-16 should makes them play together very nicely.  You simply set the
uplink frequency, find your signal on the downlink, and turn on the
CT-16.  After that the uplink radio tracks the downlink radio.  Normal
or inverted transponders are handled nicely.

I will post the entire paper to anyone who is interested, but it is
too long (27K bytes or so) to post to the group.

Randy Cole KN6W (cole@babette.isi.edu)
Citicorp-TTI
3100 Ocean Park Blvd
Santa Monica, CA  90405
(213) 452-9191

------------------------------------------------------------

COMMANDS AND REPLY MESSAGES:

Commands:.0.Set Frequency (TX Mode)
..1.Set Mode (TX Mode)
..2.Read Frequency Range
..3.Read Frequency
..4.Read Mode
..5.Set Frequency
..6.Set Mode
..7.Set VFO
..8.Set Memory
..9.Write VFO to Memory
..A.Write Memory to VFO
..B.Clear Current Memory.(currently undocumented)
..C.Read Current Offset.."
..D.Set Current Offset.."
..E.Start/Stop Scanning.."
..FA.Negative Reply
..FB.Positive Reply

DEFAULT CI-V BUS ADDRESSES:

..4.(0x04)..735
..8.(0x08)..R7000
..16.(0x10)..275A
..20.(0x14)..475A
..26.(0x1A)..R71/R71A
..28.(0x1C)..751/751A
..30.(0x1E)..761
..32.(0x20)..271A
..34.(0x22)..471A
..36.(0x24)..1271A
..238.(0xEE)..CT-16

COMMAND AND REPLY FORMATS:

Command 0 -- Set Frequency (TX Mode)

from radio.FE FE 00 rr 00 ff ff ff ff (ff) FD
..  when radio is in TX Mode and the frequency changes

to radio.FE FE 00 cc 00 ff (ff ff ff ff) FD
..  if radio is in TX Mode, or

..FE FE rr cc 00 ff (ff ff ff ff) FD
..  whether or not the radio is in TX Mode

..Frequency data starts with (10 Hz, 1 Hz) and
..increases.  The 735 uses 4 bytes, the R7000/275A/475A
..use 5..High digit bytes need not be sent if they do not
..change.

..rr is the radio's address, cc is the computer's address.
..
Command 1 -- Set Mode (TX Mode)

from radio.FE FE 00 rr 01 mm (mm) FD
..  when radio is in TX Mode and the mode changes

to radio.FE FE 00 cc 01 mm (mm) FD
..  if radio is in TX Mode, or

..FE FE rr cc 01 mm (mm) FD
..  whether or not the radio is in TX Mode

    (mode data bytes (mm) are:

      735             R7000         275A/475A

    0 - LSB         2   - AM        0   - LSB
    1 - USB         5   - FM-W      1   - USB
    2 - AM          5 2 - FM-N      3   - CW
    3 - CW          5 0 - SSB       3 2 - CW-N
    4 - RTTY                        5   - FM
    5 - FM)

Command 2 -- Read Frequency Range

to radio.FE FE rr cc 02 FD

from radio.FE FE cc rr 02 ll ll ll ll 2D uu uu uu uu FD
..  if the radio is a 735,

..FE FE cc rr 02 ll ll ll ll ll 2D uu uu uu uu uu FD
..  if the radio is a 275A or 475A, or

..FE FE cc rr 02 uu uu uu uu uu 2D ll ll ll ll ll FD
..  if the radio is an R7000.

..where ll are lower frequency digits and uu are
..upper frequency digits.

Command 3 -- Read Frequency

to radio.FE FE rr cc 03 FD

from radio.FE FE cc rr 03 ff ff ff ff (ff) FD

Command 4 -- Read Mode

to radio.FE FE rr cc 04 FD

from radio.FE FE cc rr 04 mm (mm) FD

Command 5 -- Set Frequency

to radio.FE FE rr cc 05 ff (ff ff ff ff) FD

from radio.FE FE cc rr 05 FA FD or
..FE FE cc rr 05 FB FD

Command 6 -- Set Mode

to radio.FE FE rr cc 06 mm (mm) FD

from radio.FE FE cc rr 06 FA FD or
..FE FE cc rr 06 FB FD

Command 7 -- Set VFO

to radio.FE FE rr cc 07 (vv) FD
..  If the VFO data byte (vv) is sent, 00 selects VFO A
..  and 01 selects VFO B.

from radio.FE FE cc rr 07 FA FD (always returned by a R7000) or
..FE FE cc rr 07 FB FD

Command 8 -- Set Memory

to radio.FE FE rr cc 08 nn FD
..  Where nn is the memory number.

from radio.FE FE cc rr 08 FA FD or
..FE FE cc rr 08 FB FD

Command 9 -- Write VFO to Memory

to radio.FE FE rr cc 09 FD

from radio.FE FE cc rr 09 FB FD (always, if the command packet
..  had a legal format)

Command A -- Write Memory to VFO

to radio.FE FE rr cc 0A FD

from radio.FE FE cc rr 0A FA FD (always returned by a R7000) or
..FE FE cc rr 0A FB FD

Command B -- Clear Current Memory

to radio.FE FE rr cc 0B FD

from radio.FE FE cc rr FA FD (from IC275A/475A in VFO mode) or
..FE FE cc rr FB FD (IC275A/475A in memory mode; always
..  returned by R7000)

Command C -- Read Current Offset

to radio.FE FE rr cc 0C FD

from radio.FE FE cc rr 0C ff ff ff FD or
..FE FE cc rr 0C FF FF FF FF FF FD (reply from blank
..  memory in IC275A/475A) or
..FE FE cc rr FA FD (always returned by R7000)

Command D -- Set Current Offset

to radio.FE FE rr cc 0D ff ff ff FD

from radio.FE FE cc rr FB FD or
..FE FE cc rr FA FD (always returned by R7000)

Command E -- Start/Stop Scanning

to radio.FE FE rr cc 0E ss FD (ss = 01 starts scanning,
..  ss = 00 stops scanning.  If IC275A/475A is in
..  VFO mode scanning starts at current VFO freq.,
..  if in memory mode memory scan is started)

from radio.FE FE cc rr FB FD (always returned by IC275A/475A)
..  While scanning IC275A/475A returns freq. and mode when
..  it stops on an active channel.
..FE FE cc rr FA FD (always returned by R7000)
-------
